const const_Cyclone3XULAdminPrefsRoot = "extensions.cyclone3XULAdmin.preferences.";
const const_required_framework_version = '2010.08.0.5472';

var core =
{
	
	// only proof of concept, should be rewritten
	getInstalledVersion : function(Cyclone3XULAdminExtID)
	{
		var ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
			.getService(Components.interfaces.nsIExtensionManager)
		var ext = null
		if (ExtensionManager.getItemForID)
		{
			ext = ExtensionManager.getItemForID(Cyclone3XULAdminExtID)
		}
		else
		{
			ext = ExtensionManager.getItemList(Cyclone3XULAdminExtID, null, {})[0]
		}
		return ext.version
	},
	
	update :
	{
		check : function(obj_UpdateListener, Cyclone3XULAdminExtID)
		{
			var ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
				.getService(Components.interfaces.nsIExtensionManager)
			var ext = null
			if (ExtensionManager.getItemForID)
			{
				ext = ExtensionManager.getItemForID(Cyclone3XULAdminExtID)
			}
			else
			{
				ext = ExtensionManager.getItemList(Cyclone3XULAdminExtID, null, {})[0]
			}
			ExtensionManager.update([ext], 1, false, obj_UpdateListener)
		},
		
		executeupdate : function(Cyclone3XULAdminExtID)
		{
			try
			{
				
				var extensionPrefs=new Array()
				
				var prefs = Components
					.classes["@mozilla.org/preferences-service;1"] 
					.getService(Components.interfaces.nsIPrefService)
					.getBranch(const_Cyclone3XULAdminPrefsRoot);
				prefs.setIntPref('helpdisplayed',0);
				
				var ExtensionPrefsBranch = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch(const_Cyclone3XULAdminPrefsRoot+'updates.')
				
				var ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					
				var startupCheck = ExtensionPrefsBranch.getBoolPref('startupCheck')
				
				if(startupCheck)
				{
					
					if (ExtensionManager.getItemForID)
					{
						ext = ExtensionManager.getItemForID(Cyclone3XULAdminExtID)
					}
					else
					{
						ext = ExtensionManager.getItemList(Cyclone3XULAdminExtID, null, {})[0]
					}
					
					if (typeof(InstallTrigger) != 'undefined')
					{
						var xpi = {}
						xpi[ext.name] = ext.xpiURL
						InstallTrigger.install(xpi)
					}
					else
					{
						alert('Update failed! Could not initialize InstallTrigger')
					}
				}
				
			}
			catch(e){alert(e)}
		}
	},
	
	log :
	{

		loglevel: 0,

		append : function (logText, log_level)
		{
			if (log_level)
			{
				if (log_level > this.loglevel) return;
			
			} else if (this.loglevel == 0) return;
						
			var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
				getService(Components.interfaces.nsIConsoleService);
			aConsoleService.logStringMessage(logText);
		},

		getPreferredLogLevel : function ()
		{	
			var prefs = Components
				.classes["@mozilla.org/preferences-service;1"] 
				.getService(Components.interfaces.nsIPrefService)
				.getBranch(const_Cyclone3XULAdminPrefsRoot);
			try 
			{
				var loglevel = prefs.getIntPref('logLevel');
			}catch(e)
			{
				prefs.setIntPref('logLevel',0);
				var loglevel = prefs.getIntPref('logLevel');
			}
			return loglevel;
		}
	}
	
}

var c3xuladmin = 
{
	downloadWithFileDialog : function (url, default_name, default_extension)
	{
		try
		{
			var f_picker = Components.classes["@mozilla.org/filepicker;1"].
						createInstance(Components.interfaces.nsIFilePicker);

			f_picker.defaultString = default_name + '.' + default_extension;
			f_picker.init(window, "", f_picker.modeSave);
			f_picker.appendFilter(default_extension, '*.' + default_extension);

			var result = f_picker.show();
					
              		if ((result == f_picker.returnOK) || (result == f_picker.returnReplace)) 
			{
				//var target_file = f_picker.file;

				this.downloadSilent(url, f_picker.file, default_name + '.' + default_extension);

				
			}

		}catch(e){alert(e);}
	},

	downloadSilent : function (url, target_file, description)
	{
		try
		{

			var iio_service = Components.classes["@mozilla.org/network/io-service;1"].
					getService(Components.interfaces.nsIIOService);

			var uri_source = iio_service.newURI(url, null, null);
			var uri_target = iio_service.newFileURI(target_file);

			var web_br_persist = Components.interfaces.nsIWebBrowserPersist;
			var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
					createInstance(web_br_persist);

			persist.persistFlags = web_br_persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES |
			web_br_persist.PERSIST_FLAGS_BYPASS_CACHE |
			web_br_persist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
			
			var d_manager = Components.classes["@mozilla.org/download-manager;1"].
					createInstance(Components.interfaces.nsIDownloadManager);

			var download = d_manager.addDownload(d_manager.DOWNLOAD_TYPE_DOWNLOAD, uri_source, uri_target,
				description,null, Math.round(Date.now() * 1000),
				null, persist);
			persist.progressListener = download.QueryInterface(Components.interfaces.nsIWebProgressListener);
			persist.saveURI(download.source, null, null, null, null, download.targetFile);

			
			var download_m = Components.classes["@mozilla.org/download-manager-ui;1"].
			createInstance(Components.interfaces.nsIDownloadManagerUI);
			download_m.show(window, download.id, Components.interfaces.nsIDownloadManagerUI.REASON_NEW_DOWNLOAD);

		}catch(e){alert(e);}
	}
}

//var log: function core.
function log(message, level)
{
	core.log.append(message, level)
}

core.log.loglevel = core.log.getPreferredLogLevel();

function getElementsWithAttribute(elRoot, elAttribute, objectPoll, processDepth)
{
	if(!objectPoll)
	{
		objectPoll=new Array()
	}
	if (!processDepth)
	{
		processDepth=0;
	}
	processDepth++
	if (elRoot)
	{
		var nodelist=elRoot.childNodes;
		if (!nodelist.length)
		{
			nodelist=document.getAnonymousNodes(elRoot);
		}
		if(nodelist.length)
		{
			for(var i=0;i<nodelist.length;i++)
			{
				var currentChild=nodelist[i];
				
				try 
				{
					if(currentChild.getAttribute(elAttribute.name) == elAttribute.value)
					{
						objectPoll.push(currentChild)
					}
				}catch(e){
					// for some reason it ends here. now this should be researched further.
				}

				if(currentChild.childNodes.length)
				{
					var tmpReturn=getElementsWithAttribute(currentChild, elAttribute, objectPoll, processDepth)
					objectPoll=tmpReturn
				}
				else
				{
					continue
				}
			}
		}
	}
	return objectPoll
};